<template>
  <v-container>
    <base-material-search-screen
      style="width: 100%"
      title="Trả góp"
      :disabled2="false"
      :disabled3="false"
      text3="CẬP NHẬT TRẠNG THÁI"
      @action-1="addChiTieu()"
      @action-2="confirmDeleteChiTieu()"
      @action-3="showTotal()"
    >
      <!-- desktop -->
      <v-row v-if="!isMobile()">
        <v-col class="mt-0 pt-1">
          <v-data-table
            v-model="selected"
            :headers="headers"
            :items="chiTieuList"
            :single-select="singleSelect"
            :search="search"
            class="elevation-1 table-list"
            fixed-header
            height="510"
          >
            <!-- Search -->
            <template v-slot:top>
              <v-row class="ml-1 mr-1">
                <v-col cols="12" lg="2" XS="3" class="pb-0 text-right">
                  <v-checkbox
                    label="GIA ĐÌNH"
                    color="red"
                    hide-details
                    @change="filterStatus($event, 'GD', 'MUCDICH')"
                  />
                 
                </v-col>
                <v-col cols="12" lg="2" class="pb-0 text-right">
                  <v-checkbox
                    label="HSBC"
                    color="red"
                    hide-details
                    @change="filterStatus($event, 'HSBC', 'BANK')"
                  />
                </v-col>
                <v-col cols="12" lg="2" class="pb-0 text-right">
                  <v-checkbox
                    label="SC BANK"
                    color="red"
                    hide-details
                    @change="filterStatus($event, 'SC BANK', 'BANK')"
                  />
                </v-col>
                <v-col cols="12" lg="2" class="pb-0 text-right">
                  <v-checkbox
                    label="CITI BANK"
                    color="red"
                    hide-details
                    @change="filterStatus($event, 'CITI BANK', 'BANK')"
                  />
                </v-col>
                <v-col cols="12" lg="4" XS="12" class="pb-0">
                  <v-text-field
                    v-model="search"
                    label="Tìm kiếm"
                    class="mx-4 pt-5 ma-0 pb-2"
                    hide-details=""
                  />
                </v-col>
              </v-row>
            </template>
            <!-- body -->
            <template v-slot:item.noi_dung="{ item }">
              <router-link
                v-slot="{ href, route, navigate, isActive, isExactActive }"
                :to="{ name: 'CHI TIET SAN PHAM', params: { id: item.id } }"
              >
                <a :href="href" @click="navigate">{{ item.noi_dung }}</a>
              </router-link>
            </template>

            <template v-slot:item.tong_tien="{ item }">
              {{ formatPrice(item.tong_tien, 2) }}
            </template>
            <template v-slot:item.ngay_mua="{ item }">
              {{ 
                moment(String( item.ngay_mua)).format('DD/MM/YYYY hh:mm')
              }} 
            </template>

          </v-data-table>
        </v-col>
      </v-row>
      <!-- end desktop -->

      <!-- mobile-->
      <v-row v-else>
        <v-row cols="12" class="pa-1 ma-1 pt-0">
          <v-col cols="12" class="pb-0 text-right mt-0 pt-0">
            <!-- <v-checkbox
              label="GIA ĐÌNH"
              color="red"
              hide-details
              @change="filterStatus($event, 'GD', 'MUCDICH')"
            /> -->
             <v-autocomplete
              ref="refMucDich"
              :items="lstMucDich"
              return-object
              item-text="name"
              item-value="id"
              label="Mục đích"
              class="text-left"
              hide-details=""
              clearable
              @change="filterStatus($event, 'CBO-MD', 'BANK')"
              multiple
            />
          </v-col>
          <v-col cols="6" class="pb-0 text-right mt-0 pt-0">
             <v-autocomplete
              ref="refStatus"
              :items="lstStatus"
              return-object
              item-text="name"
              item-value="id"
              label="Trạng thái"
              class="text-left"
              hide-details=""
              clearable
              @change="filterStatus($event, 'CBO-STS', 'BANK')"
              multiple
            />
          </v-col>
          <v-col cols="6" class="pb-0 text-right mt-0 pt-0">
             <v-autocomplete
              ref="refKyChi"
              :items="lstKyChi"
              v-model="kyChiSeleted"
              return-object
              label="Kỳ Chi"
              class="text-left"
              hide-details=""
              clearable
              @change="filterStatus($event, 'CBO-KYCHI', 'KY_CHI')"
              multiple
            />
          </v-col>
          <v-col cols="8" class="text-right mt-0">
            <!-- <v-checkbox
              label="GIA ĐÌNH"
              color="red"
              hide-details
              @change="filterStatus($event, 'GD', 'MUCDICH')"
            /> -->
             <v-autocomplete
              ref="refBank"
              :items="lstBank"
              v-model="bankSeleted"
              return-object
              item-text="name"
              item-value="id"
              label="Bank"
              class="text-left"
              hide-details=""
              multiple
              clearable
              @change="filterStatus($event, 'CBO-BANK', 'BANK')"
            />
          </v-col>
          <v-col cols="4" class="pb-0 text-right pl-0">
            <v-btn
              color="purple"
              class="mt-1 text-right"
              width="120px"
              @click="updateSts($event, 'CSK')"
            >
              <span class="pr-1">
                Chốt SK
              </span>
              <v-icon 
              >
                save
              </v-icon>
            </v-btn>
          </v-col>
        </v-row>
        <v-col class="mt-0 pt-1 pa-1">
          <v-list subheader>
            <v-col cols="12" class="mt-0 pt-0 mb-0 pb-0">
              <strong style="font-size: 14pt">Danh sách chi tiêu</strong>
            </v-col>
            <v-col cols="12" class="mt-0 pt-0 mb-0 pb-0">
              <v-row>
                <v-col cols="6" class="text-center mt-0 pt-0 mb-0 pb-0">
                  <strong>
                    Tổng chi
                  </strong>
                </v-col>
                <v-col cols="6" class="text-center mt-0 pt-0 mb-0 pb-0">
                  <strong>
                   Còn lại
                  </strong>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="6" class="text-center mt-0 pt-0 mb-0 pb-0">
                  <strong>
                  {{  
                    formatPrice(this.chitieu.filter(sts => sts.datetype === 'month').pop().total , 2) 
                  }}
                  </strong> 
                </v-col>
                <v-col cols="6" class="text-center mt-0 pt-0 mb-0 pb-0">
                  <strong>
                  {{  
                    formatPrice(this.chitieu.filter(sts => sts.datetype === 'balance').pop().total , 2) 
                  }} 
                  </strong>
                </v-col>
              </v-row>
            </v-col>

            <v-list-item v-for="detail in chiTieuList" :key="detail.order_code">
              <v-list-item-content>
                <strong>
                  <router-link
                    v-slot="{ href, route, navigate, isActive, isExactActive }"
                    :to="{ name: 'CHI TIET SAN PHAM', params: { id: detail.id } }"
                  >
                    <a :href="href" @click="navigate" class="font-size: 13pt">{{ detail.noi_dung }}</a>
                  </router-link>
                </strong>
                <strong class="pt-2"> Số tiền: {{ formatPrice(detail.so_tien, 2) }} </strong>
                <strong class="pt-2">Status: {{ lstStatus.filter(sts => sts.id === detail.status).pop().name }} </strong>
                <span class="pt-2">Bank: {{ detail.bank_code }} </span>
                <span class="pt-2">Mục đích: {{ lstMucDich.filter(sts => sts.id === detail.muc_dich).pop().name }} </span>
                <v-divider hieght="2px"/>
                
              </v-list-item-content>

              <v-list-item-icon>
                <v-row col="12">
                  <v-icon color="red" large @click="confirmDeleteChiTieu(detail)">
                    delete
                  </v-icon>
                </v-row>
                <!-- <v-row col="12">
                  <v-icon right
                     @click="orderDetailDialog(item)"
                  >
                    edit
                  </v-icon>
                </v-row> -->
              </v-list-item-icon>
            </v-list-item>
            <v-divider inset></v-divider>
          </v-list>
        </v-col>
      </v-row>
      <!-- end mobile-->
      <v-row>
        <addProduct
          ref="addProductDialog"
          :v-model="dialog"
          @refeshList="getChiTieus"
        />
      </v-row>
      <v-row>
        <addChiTieu
          ref="addChiTieu"
          :v-model="dialogChiTieu"
          @refeshList="getChiTieus"
        />
      </v-row>

      <v-row>
        <updateStatus
          ref="refUpdateStatus"
          :v-model="dialogChiTieu"
          @refeshList="getChiTieus"
        />
      </v-row>

      
      <v-row>
        <dialogConfirm
          ref="dialogConfirm"
          :v-model="dialogConfirm"
          :title="titleConfirm"
          :content="contentConfirm"
          @select-ok="deleteChiTieu()"
        />
      </v-row>

      <v-row>
        <dialogAlert ref="dialogAlert" :v-model="dialogAlert" />
      </v-row>

      <v-row>
        <snackbarNew ref="snackNotification" :v-model="snackbar" />
      </v-row>

      <v-row>
        <chiTieuTotal 
          ref="chiTieuTotal" 
          :v-model="chiTieuTotalDialog" />
      </v-row>
      <v-row>
        <addChiTieu
          ref="addChiTieu"
          @refeshList="getChiTieus()"
          :v-model="dialogChiTieu"
        />
      </v-row>
    </base-material-search-screen>
  </v-container>
</template>

<script>
  import axios from 'axios'
  import moment from 'moment'
  import { NumericInput } from 'numeric-keyboard'
  import config from '../../config/config'
  import addProduct from '../sales/add-product'
  import addChiTieu from '../kinhte/add-chitieu'
  import chiTieuTotal from '../kinhte/chi-tieu-total'
  import updateStatus from '../kinhte/update-status-chitieu'
  
  import dialogConfirm from '../dashboard/component/dialogConfirm'
  import dialogAlert from '../dashboard/component/dialogAlert'
  import snackbarNew from '../dashboard/component/snackbarNew'
  import orderDetail from '../sales/sale-order-detail'
  import VComponent from '../../components/base/VComponent.vue'
  import Buttons from '../dashboard/component/Buttons.vue'

  export default {
    layout: 'SaleStorage',
    components: {
      // materialCard,
      // ProgressBar,
      addProduct,
      addChiTieu,
      dialogConfirm,
      dialogAlert,
      snackbarNew,
      orderDetail,
      chiTieuTotal,
      updateStatus,
      NumericInput,
    // VueEllipseProgress
    },
    props: {
      // change the layout of keyboard
      layout: {
      type: [String, Array],
      default: 'number'
      },
      // change the label of keyboard enter key, use iconfont for icon.
      entertext: {
      type: String,
      default: 'enter'
      }
    },
    data () {
      return {
        search: '',
        amount: '',
        dialog: false,
        singleSelect: false,
        selected: [],
        dialogStatus: false,
        dialogChiTieu: false,
        dialogConfirm: false,
        dialogAlert: false,
        chiTieuTotalDialog: false,
        pageCount: 0,
        itemPerPage: 5,
        bankList: [],
        kyChiSeleted: [],
        bankSeleted: [],
        chiTieuList: [],
        order_customer_type: 'KL',
        knowledge: 30,
        orderDetail: false,
        show: false,
        color: null,
        colors: ['purple', 'info', 'success', 'warning', 'error'],
        top: true,
        bottom: false,
        left: false,
        right: false,
        snackbar: false,
        titleConfirm: 'Xác nhận',
        contentConfirm: 'Bạn có chắc chắn muốn xóa đơn hàng này không?',
        saleOrder: {
          order_customer_type: 'KL',
        },
        customerTypeModal: {
          ALL: false,
          KS: false,
          KL: false,
          CTV: false,
        },
        snackbarContent:
          'Đã có lỗi hệ thống xảy ra, vui lòng kiểm tra lại hoặc liên hệ với admin!!!',
        pagination: {
          ascending: true,
          sortBy: 'name',
          rowsPerPage: 10,
          page: 1,
        },
        headers: [
          {
            text: '#',
            sortable: false,
            width: '20px',
            format: (v) => v && String(v),
          },
          {
            text: 'SẢN PHẨM TRẢ GÓP',
            sortable: false,
            align: 'left',
            value: 'san_pham',
          },
          {
            text: 'SỐ TIỀN',
            sortable: false,
            value: 'tong_tien',
            align: 'right',
            format: (v) => v && Number(v).toFixed(2),
          },
          {
            text: 'BANK',
            sortable: false,
            value: 'bank',
            align: 'center',
          },
          {
            text: 'TỔNG SỐ KỲ',
            sortable: false,
            value: 'bank_code',
          },
          {
            text: 'NGÀY MUA',
            sortable: false,
            value: 'ngay_mua',
            align: 'center',
            format: (v) => v && Number(v).toFixed(2),
          },
          {
            text: 'KỲ ĐÃ TRẢ',
            value: '_ky_da_tra',
            align: 'center',
          },
           {
            text: 'Kỳ còn lại',
            value: '_ky_con_lai',
            align: 'center',
          },
          {
            text: 'NƠI MUA',
            align: 'left',
            value: 'noi_mua',
          },
          
        ],
        items: [],
        itemDetail: [],
        chiTieuSelected: [],
        lstStatus: [
          {
            id: 'DCHI'
            , name: 'Dự Chi'
            },
            {
            id: 'CHM'
            , name: 'Cho Mượn'
            },
            {
            id: 'DTT'
            , name: 'Đã Tất Toán'
            },
            {
            id: 'DN'
            , name: 'Dư Nợ'
            },
            {
            id: 'DTCSK'
            , name: 'Đã Trả / CSK'
            },
            {
            id: 'DTN'
            , name: 'Đã trả nợ'
            },
            {
            id: 'NHT'
            , name: 'Nhận tiền'
            },
            {
            id: 'HTN'
            , name: 'Hoàn Tiền'
            },
            {
            id: 'MNT'
            , name: 'Mượn Tiền'
            },
          ],
          lstMucDich: [
              {
                id: 'KD',
                name: 'KINH DOANH'
              },
              {
                id: 'GD',
                name: 'GIA ĐÌNH'
              },
              {
                id: 'CN',
                name: 'CÁ NHÂN'
              },
              {
                id: 'CM',
                name: 'CHO MƯỢN'
              },
              {
                id: 'GDAE',
                name: 'GĐ-ANH EM'
              }
          ],
          lstKyChi: ['12019'
                ,'22019'
                ,'32019'
                ,'42019'
                ,'52019'
                ,'62019'
                ,'72019'
                ,'82019'
                ,'92019'
                ,'102019'
                ,'112019'
                ,'122019'
                ,'12020'
                ,'22020'
                ,'32020'
                ,'42020'
                ,'52020'
                ,'62020'
                ,'72020'
                ,'82020'
                ,'92020'
                ,'102020'
                ,'112020'
                ,"122020"
                ,'12021'
                ,'22021'
                ,'32021'
                ,'42021'
                ,'52021'
                ,'62021'
                ,'72021'
                ,'82021'
                ,'92021'
                ,'102021'
                ,'112021'
                ,'122021'
        ],

          chitieu: {
          },
          lstBank: [],
          originListChiTieu: [],
      }
    },
    computed: {
    //   ...bankState("bank", {
    //     bankList: "bankList",
    // })
    }, // end method
    created () {
      this.getBanks()
      this.getChiTieus()
      this.getKyTinh('HSBC', new Date(), new Date().getDate())
      this.getKyTinh('SC BANK', new Date(), new Date().getDate())
      this.getKyTinh('CitiBank', new Date(), new Date().getDate())
    },
    methods: {
      isMobile() {
        if(/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
          return true
        } else {
          return false
        }
      },
      addChiTieu () {
        // this.$router.push({ name: 'CHI TIẾT CHI TIÊU' })
         this.$refs.addChiTieu.chiTieuModel.so_tien = 0
         this.$refs.addChiTieu.chiTieuModel.status = 'DN'
         this.$refs.addChiTieu.chiTieuModel.noi_dung = []
         this.$refs.addChiTieu.chiTieuModel.ghi_chu = ''

        //  this.$refs.addChiTieu.dialog = true
        this.$router.push({ name: 'Thêm chi tiêu' })
        
      },
      async getBanks () {
        const seft = this
        await axios
        .get(config.API_FAMILY + '/api/banks')
        .then(function (response) {
          // this.insertChitieuDialog.dialog = false;
          console.log(response.data.data)
          seft.lstBank = response.data.data
          
        })
      },
      async getChiTieus () {
        const self = this
        console.log('getChiTieus')
        console.log(this.saleOrder)

        var orderType = []
        if (!this.customerTypeModal.ALL) {
          if (this.customerTypeModal.KS) {
            orderType.push("'KS'")
          }
          if (this.customerTypeModal.KL) {
            orderType.push("'KL'")
          }
          if (this.customerTypeModal.CTV) {
            orderType.push("'CTV'")
          }
        } else {
          orderType.push("'KL'")
          orderType.push("'KS'")
          orderType.push("'CTV'")
        }
        console.log(orderType.toString())
        this.saleOrder.order_customer_type = orderType.join()
        await axios
          .get(config.API_FAMILY + '/api/getListTraGop', this.saleOrder)
          .then(function (response) {
            self.chiTieuList = response.data.data
            self.originListChiTieu = response.data.data
            self.totalChiTieu()
            console.log(JSON.stringify(self.chiTieuList))
          })
      },
      confirmDeleteChiTieu (detail) {
        // this.$refs.dialogConfirm.title = 'Xác nhận'
        // this.$refs.dialogConfirm.text = 'Bạn có chắc chắn muốn xóa đơn hàng này không?'
        if(detail != undefined && detail != null){
          this.chiTieuSelected = detail
        }
        this.$refs.dialogConfirm.dialog = true
      },
      
      async deleteChiTieu () {
        
        let itemDelete = this.selected;
        if(this.chiTieuSelected != undefined && this.chiTieuSelected != null){
          itemDelete = this.chiTieuSelected
        }
        console.log("a")
        console.log(itemDelete)
        if (itemDelete !== undefined && itemDelete != null) {
          const seft = this
          const jsonReq = JSON.stringify(itemDelete)

          await axios
            .post(config.API_FAMILY + '/api/deleteChiTieu', JSON.parse(jsonReq))
            .then(function (response) {
              console.log("succuess")
              var data = response.data.data
              if (data !== undefined && data != null) {
              }
              seft.getChiTieus()
              
              seft.$refs.dialogConfirm.dialog = false
            }).catch((error) => {
              console.log(error)
            })
        }
      },

      updateSts (obj, type) {
        this.$refs.refUpdateStatus.dialog = true
        // let self = this;
        // console.log("UPDATE STATUS")
        // console.log(this.kyChiSeleted)
        // console.log(this.bankSeleted)
        
        // console.log("END UPDATE STATUS")
        // if('CSK' == type){
        //   //Chốt sao kê
         
        //   if (this.bankSeleted != undefined && this.bankSeleted.length > 0
        //       && this.kyChiSeleted != undefined && this.kyChiSeleted.length > 0) {

        //     let reqBank = [];
        //     for (var key in this.bankSeleted) {
        //       reqBank.push(this.bankSeleted[key].name)
        //     }
        //     let params = {
        //       ghi_chu: "",
        //       status: "DTCSK",
        //       bank_code: reqBank ,
        //       ky_chi: this.kyChiSeleted,

        //     }
        //     await axios
        //     .post(config.API_FAMILY + '/api/updateStatusByBank', params)
        //     .then(function (response) {
        //       console.log("succuess")
        //       var data = response.data.data
        //       if (data !== undefined && data != null) {
        //       }
        //       self.getChiTieus()
              
        //       // seft.$refs.dialogConfirm.dialog = false
        //     }).catch((error) => {
        //       console.log(error)
        //     })
        //   }
        // }
      },
      showTotal () {
        // alert('a')
        this.$refs.chiTieuTotal.dialog = true;
      },
      formatPrice (value, tofix) {
        const val = (value / 1).toFixed(tofix).replace(',', '.')
        return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',')
      },
      getKyTinh(sbankObj, sDate, sDay){
        var kyTinh = "";
        var deltaMonth = 1;
        var month = sDate.getMonth();
        var deltaYear = 0;
        if(sbankObj != undefined && sbankObj != null){
          var sBanName = sbankObj.name;
          if(((sBanName == "HSBC" || sBanName == "SHINHAN") && (sDay + 1) >= 21)
            || (sBanName == "SC BANK" && (sDay + 1) >= 19)
            || (sBanName == "CitiBank" && (sDay + 1) >= 27)){
              deltaMonth = 2;
              
          }else{
              deltaMonth = 1;
          }
        
          if(sDate.getMonth() + deltaMonth > 12){
            deltaYear = 1;
            kyTinh = "1" + (sDate.getFullYear() + deltaYear).toString();
          }else{
            kyTinh = (month + deltaMonth).toString() + (sDate.getFullYear() + deltaYear).toString();
          }
        }
        console.log("year:" + sDate.getFullYear());
        console.log("kyTinh-" + sBanName + ":" + kyTinh);
        return kyTinh;
      },
      async totalChiTieu () {
        const self = this
        await axios
          .get(config.API_FAMILY + '/api/totalChiTieu')
          .then(function (response) {
            self.chitieu = response.data.data
            console.log(JSON.stringify(self.chitieu))
          })
      },
      moment: function (date) {
        return moment(date);
      },
      date: function (date) {
        return moment(date).format('MMMM Do YYYY, h:mm:ss a');
      },
      
      snackbaralert (...args) {
        if (args === undefined || args < 3) {
          this.$refs.snackNotification.color = this.colors[4]
          this.$refs.snackNotification.snackbarContent =
            'Đã có lỗi xảy ra, vui lòng liên hệ admin'
          this.$refs.snackNotification.snackbar = true
        } else {
          this.$refs.snackNotification.color = args[0]
          this.$refs.snackNotification.snackbarContent = args[1]
          this.$refs.snackNotification.snackbar = true
        }
      },
      filterStatus (filter, value, colType){
        console.log("fiter")
        console.log(filter)
        if('CBO-BANK' == value){
          const lstTemp2 = this.chiTieuList
          let chiTieuListNew = []
          if(filter != undefined && filter.length > 0) {       
            var newList = this.originListChiTieu;                            
            newList = newList.filter(function(item) {
              for (var key in filter) {
                console.log("AB: " + item.bank_code + " : " + filter[key].name)
                if(item.bank_code ==  filter[key].name)
                  return true
              }
              
              return false
            });
            this.chiTieuList = newList
          }else{
            this.chiTieuList = this.originListChiTieu
          }
          
        } else if('CBO-MD' == value){
          const lstTemp2 = this.chiTieuList
          let chiTieuListNew = []
          if(filter != undefined && filter.length > 0) {       
            var newList = this.originListChiTieu;                            
            newList = newList.filter(function(item) {
              for (var key in filter) {
                console.log("AB: " + item.muc_dich + " : " + filter[key].name)
                if(item.muc_dich ==  filter[key].id)
                  return true
              }
              
              return false
            });
            this.chiTieuList = newList
          }else{
            this.chiTieuList = this.originListChiTieu
          }
        } else if('CBO-STS' == value){
          const lstTemp2 = this.chiTieuList
          let chiTieuListNew = []
          if(filter != undefined && filter.length > 0) {       
            var newList = this.originListChiTieu;                            
            newList = newList.filter(function(item) {
              for (var key in filter) {
                if(item.status ==  filter[key].id)
                  return true
              }
              
              return false
            });
            this.chiTieuList = newList
          }else{
            this.chiTieuList = this.originListChiTieu
          }
        }
      }
    },
    filters: {
      moment: function (date) {
        return moment(date).format('MMMM Do YYYY, h:mm:ss a');
      }
  },
    
  }
</script>
<style scroped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
/* .table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
} */
</style>
